# CR Component 9
# Allow user to choose number of dice

import random


# Functions go here...

# function below races cars.  Previous winners populates a list which prevents cars which have
# won / placed from continuing to race.  Status is the placing (win, 1st or 2nd) and rolls
# is needed to keep track of the 'time'.  Both previous winners and rolls are returned
# as a list so that these variables can be passed back into the function for the 2nd and 3rd places.
def race_them(competitors, num_dice, previous_winners, status, rolls):

    # initialise local variables
    longest = ""
    place_winners = previous_winners

    while len(longest) < distance + len(name):
        if num_dice == 2:
            dice_throw = random.randint(1,6) + random.randint(1,6)            # rolls two dice
        else:
            dice_throw = random.randint(1,6)        # rolls one die

        if dice_throw not in place_winners:
            competitors[dice_throw - 1] += "0"   # add '0' to show car progress
            rolls += 1      # count dice roll only if it is not in place_winner list
        longest = max(all_cars, key=len)            # update longest so while loop ends

        place = longest[5:7]

    used = int(place)
    place_winners.append(used)  # add place winners to list so car is out of race

    # Put in place...
    to_label = competitors.index(longest)
    competitors[to_label] = "car #{} | {}".format(place, status)

    # print diagram (shows Placing)
    for item in competitors:
        print(item, sep="")

    # print win statement
    print()
    print("{}: car #{} \t Time: {} throws".format(status, place, rolls))

    # Return rolls
    return [place_winners, rolls]   # use a list to return more than one piece of data!

# function below checks that user input is an integer
def intcheck(question, low=None, high=None):

    # sets up error messages
    if low is not None and high is not None:
            error = "Please enter an integer between {} and {} " \
                    "(inclusive)".format(low, high)
    elif low is not None and high is None:
        error = "Please enter an integer that is more than or " \
                "equal to {}".format(low)
    elif low is None and high is not None:
        error = "Please enter an integer that is less than or " \
                "equal to {}".format(high)
    else:
        error = "Please enter an integer"

    while True:

        try:
            response = int(input(question))

            # Checks response is not too low
            if low is not None and response < low:
                print(error)
                continue

            # Checks response is not too high
            if high is not None and response > high:
                print(error)
                continue

            return response

        except ValueError:
            print(error)
            continue

# Main Routine...
# variables set up
distance = 10   # Replace with user input in due course
var_num_dice = intcheck("How many dice should I use <1 or 2>? ", 1, 2)

# Make cars...
# Create car strings (ie: car 1 to 12)
all_cars = []

if var_num_dice == 1:
    top_val = 7
else:
    top_val = 13

for item in range (1, top_val):
    # for single digit strings note the space between the # and the number
    if 1 <= item <= 9:
        name = "car # {} | ".format(item)
    else:
        name = "car #{} | ".format(item)
    all_cars.append(name)

find_winner = race_them(all_cars, var_num_dice, [], "** 1st **", 0)
input("Please press <enter>")
find_second = race_them(all_cars, var_num_dice, find_winner[0], "* 2nd *", find_winner[1])
input("Please press <enter>")
find_third = race_them(all_cars, var_num_dice, find_second[0], "* 3rd *", find_second[1])
