# CR Component 12
# Entire Game Loops


import random

# Functions go here...

# function below races cars.  Previous winners populates a list which prevents cars which have
# won / placed from continuing to race.  Status is the placing (win, 1st or 2nd) and rolls
# is needed to keep track of the 'time'.  Both previous winners and rolls are returned
# as a list so that these variables can be passed back into the function for the 2nd and 3rd places.
def race_them(competitors, num_dice, previous_winners, status, rolls):

    # initialise local variables
    longest = ""
    place_winners = previous_winners

    while len(longest) < distance + len(name):
        if num_dice == 2:
            dice_throw = random.randint(1,6) + random.randint(1,6)            # rolls two dice
        else:
            dice_throw = random.randint(1,6)        # rolls one die

        if dice_throw not in place_winners:
            competitors[dice_throw - 1] += "0"   # add '0' to show car progress
            rolls += 1      # count dice roll only if it is not in place_winner list
        longest = max(all_cars, key=len)            # update longest so while loop ends

        place = longest[5:7]

    used = int(place)
    place_winners.append(used)  # add place winners to list so car is out of race

    # Put in place...
    to_label = competitors.index(longest)
    competitors[to_label] = "car #{} | {}".format(place, status)

    # print diagram (shows Placing)
    for item in competitors:
        print(item, sep="")

    # print win statement
    print()
    print("{}: car #{} \t Time: {} throws".format(status, place, rolls))

    # Return rolls
    return [place_winners, rolls, place]   # use a list to return more than one piece of data!

# function below checks that user input is an integer
def intcheck(question, low=None, high=None):

    # sets up error messages
    if low is not None and high is not None:
            error = "Please enter an integer between {} and {} " \
                    "(inclusive)".format(low, high)
    elif low is not None and high is None:
        error = "Please enter an integer that is more than or " \
                "equal to {}".format(low)
    elif low is None and high is not None:
        error = "Please enter an integer that is less than or " \
                "equal to {}".format(high)
    else:
        error = "Please enter an integer"

    while True:

        try:
            response = int(input(question))

            # Checks response is not too low
            if low is not None and response < low:
                print(error)
                continue

            # Checks response is not too high
            if high is not None and response > high:
                print(error)
                continue

            return response

        except ValueError:
            print(error)
            continue

# Main Routine...

print("**** Welcome *****")
print()
print("Intro / instructions go here")
print()

keep_going = ""
while keep_going == "":
    # variables set up
    distance = intcheck("How long should the race be <min 10, max 25>? ", 10, 25)
    var_num_dice = intcheck("How many dice should I use <1 or 2>? ", 1, 2)

    num_rounds = intcheck("How many rounds would you like to play? ", 1)
    rounds_played = 0
    score = 0

    # Make cars...
    # Create car strings (ie: car 1 to 12)

    while rounds_played < num_rounds:
        all_cars = []

        if var_num_dice == 1:
            top_val = 7
        else:
            top_val = 13

        for item in range (1, top_val):
            # for single digit strings note the space between the # and the number
            if 1 <= item <= 9:
                name = "car # {} | ".format(item)
            else:
                name = "car #{} | ".format(item)
            all_cars.append(name)

        print()
        input("Press <enter> to Play...")

        print()
        print("Round {} of {}".format(rounds_played+1, num_rounds))
        print()
        user_choice = intcheck("Choose a car: ", 1, top_val-1)

        print()

        # Race cars and find place holders
        print()
        find_winner = race_them(all_cars, var_num_dice, [], "** 1st **", 0)

        round_score = 0
        if user_choice == int(find_winner[2]):
            print("****  Congratulations!  You came first. ****")
            round_score = 5
        input("Please press <enter>")
        find_second = race_them(all_cars, var_num_dice, find_winner[0], "* 2nd *", find_winner[1])
        if user_choice == int(find_second[2]):
            print("**** Well done, your car came in second ****")
            round_score = 3
        input("Please press <enter>")
        find_third = race_them(all_cars, var_num_dice, find_second[0], "* 3rd *", find_second[1])
        if user_choice == int(find_third[2]):
            print("**** Yay!  your car came in third ****")
            round_score = 1
        rounds_played += 1
        score += round_score

        print("Score for this round: {} \t Total Score: {}".format(round_score, score))
        print()

    keep_going = input("Press <enter> to play again or any key to quit...")
    print()

print("Thanks for playing!")
